/[gentoo-x86]/eclass/kernel-2.eclass
Gentoo

Diff of /eclass/kernel-2.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.60 Revision 1.232
1# Copyright 1999-2004 Gentoo Foundation 1# Copyright 1999-2009 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/kernel-2.eclass,v 1.60 2004/12/02 21:22:15 vapier Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/kernel-2.eclass,v 1.232 2010/05/02 08:48:16 robbat2 Exp $
4 4
5# Description: kernel.eclass rewrite for a clean base regarding the 2.6 5# Description: kernel.eclass rewrite for a clean base regarding the 2.6
6# series of kernel with back-compatibility for 2.4 6# series of kernel with back-compatibility for 2.4
7# 7#
8# Maintainer: John Mylchreest <johnm@gentoo.org> 8# Original author: John Mylchreest <johnm@gentoo.org>
9# Copyright 2004 Gentoo Linux 9# Maintainer: kernel-misc@gentoo.org
10# 10#
11# Please direct your bugs to the current eclass maintainer :) 11# Please direct your bugs to the current eclass maintainer :)
12 12
13# added functionality: 13# added functionality:
14# unipatch - a flexible, singular method to extract, add and remove patches. 14# unipatch - a flexible, singular method to extract, add and remove patches.
15 15
16# A Couple of env vars are available to effect usage of this eclass 16# A Couple of env vars are available to effect usage of this eclass
17# These are as follows: 17# These are as follows:
18# 18#
19# K_USEPV - When setting the EXTRAVERSION variable, it should
20# add PV to the end.
21# this is useful for thigns like wolk. IE:
22# EXTRAVERSION would be something like : -wolk-4.19-r1
19# K_NOSETEXTRAVERSION - if this is set then EXTRAVERSION will not be 23# K_NOSETEXTRAVERSION - if this is set then EXTRAVERSION will not be
20# automatically set within the kernel Makefile 24# automatically set within the kernel Makefile
21# K_NOUSENAME - if this is set then EXTRAVERSION will not include the 25# K_NOUSENAME - if this is set then EXTRAVERSION will not include the
22# first part of ${PN} in EXTRAVERSION 26# first part of ${PN} in EXTRAVERSION
27# K_NOUSEPR - if this is set then EXTRAVERSION will not include the
28# anything based on ${PR}.
23# K_PREPATCHED - if the patchset is prepatched (ie: mm-sources, 29# K_PREPATCHED - if the patchset is prepatched (ie: mm-sources,
24# ck-sources, ac-sources) it will use PR (ie: -r5) as 30# ck-sources, ac-sources) it will use PR (ie: -r5) as
25# the patchset version for 31# the patchset version for
26# - and not use it as a true package revision 32# and not use it as a true package revision
27# K_EXTRAEINFO - this is a new-line seperated list of einfo displays in 33# K_EXTRAEINFO - this is a new-line seperated list of einfo displays in
28# postinst and can be used to carry additional postinst 34# postinst and can be used to carry additional postinst
29# messages 35# messages
36# K_EXTRAELOG - same as K_EXTRAEINFO except using elog instead of einfo
30# K_EXTRAEWARN - same as K_EXTRAEINFO except ewarn's instead of einfo's 37# K_EXTRAEWARN - same as K_EXTRAEINFO except using ewarn instead of einfo
38# K_SYMLINK - if this is set, then forcably create symlink anyway
39#
40# K_DEFCONFIG - Allow specifying a different defconfig target.
41# If length zero, defaults to "defconfig".
42# K_WANT_GENPATCHES - Apply genpatches to kernel source. Provide any
43# combination of "base" and "extras"
44# K_GENPATCHES_VER - The version of the genpatches tarball(s) to apply.
45# A value of "5" would apply genpatches-2.6.12-5 to
46# my-sources-2.6.12.ebuild
47# K_SECURITY_UNSUPPORTED- If set, this kernel is unsupported by Gentoo Security
48# K_DEBLOB_AVAILABLE - A value of "0" will disable all of the optional deblob
49# code. If empty, will be set to "1" if deblobbing is
50# possible. Test ONLY for "1".
51# K_PREDEBLOBBED - This kernel was already deblobbed elsewhere.
52# If false, either optional deblobbing will be available
53# or the license will note the inclusion of freedist
54# code.
31 55
32# H_SUPPORTEDARCH - this should be a space separated list of ARCH's which 56# H_SUPPORTEDARCH - this should be a space separated list of ARCH's which
33# can be supported by the headers ebuild 57# can be supported by the headers ebuild
34 58
35# UNIPATCH_LIST - space delimetered list of patches to be applied to the 59# UNIPATCH_LIST - space delimetered list of patches to be applied to the
36# kernel 60# kernel
37# UNIPATCH_EXCLUDE - an addition var to support exlusion based completely 61# UNIPATCH_EXCLUDE - an addition var to support exlusion based completely
38# on "<passedstring>*" and not "<passedno#>_*" 62# on "<passedstring>*" and not "<passedno#>_*"
39# - this should _NOT_ be used from the ebuild as this is 63# - this should _NOT_ be used from the ebuild as this is
40# reserved for end users passing excludes from the cli 64# reserved for end users passing excludes from the cli
41# UNIPATCH_DOCS - space delimemeted list of docs to be installed to 65# UNIPATCH_DOCS - space delimemeted list of docs to be installed to
42# the doc dir 66# the doc dir
43# UNIPATCH_STRICTORDER - if this is set places patches into directories of 67# UNIPATCH_STRICTORDER - if this is set places patches into directories of
44# order, so they are applied in the order passed 68# order, so they are applied in the order passed
45 69
46ECLASS="kernel-2" 70inherit eutils toolchain-funcs versionator multilib
47INHERITED="$INHERITED $ECLASS"
48EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_preinst pkg_postinst 71EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_preinst pkg_postinst
49 72
73# Added by Daniel Ostrow <dostrow@gentoo.org>
74# This is an ugly hack to get around an issue with a 32-bit userland on ppc64.
75# I will remove it when I come up with something more reasonable.
76[[ ${PROFILE_ARCH} == "ppc64" ]] && CHOST="powerpc64-${CHOST#*-}"
77
50export CTARGET="${CTARGET:-${CHOST}}" 78export CTARGET=${CTARGET:-${CHOST}}
79if [[ ${CTARGET} == ${CHOST} && ${CATEGORY/cross-} != ${CATEGORY} ]]; then
80 export CTARGET=${CATEGORY/cross-}
81fi
51 82
52HOMEPAGE="http://www.kernel.org/ http://www.gentoo.org/" 83HOMEPAGE="http://www.kernel.org/ http://www.gentoo.org/ ${HOMEPAGE}"
84[[ -z ${LICENSE} ]] && \
53LICENSE="GPL-2" 85 LICENSE="GPL-2"
54IUSE="${IUSE} build doc" 86
55SLOT="${PVR}" 87# This is the latest KV_PATCH of the deblob tool available from the
88# libre-sources upstream.
89[[ -z ${DEBLOB_MAX_VERSION} ]] && DEBLOB_MAX_VERSION=33
90
91# No need to run scanelf/strip on kernel sources/headers (bug #134453).
92RESTRICT="binchecks strip"
56 93
57# set LINUX_HOSTCFLAGS if not already set 94# set LINUX_HOSTCFLAGS if not already set
95[[ -z ${LINUX_HOSTCFLAGS} ]] && \
58[ -z "$LINUX_HOSTCFLAGS" ] && LINUX_HOSTCFLAGS="-Wall -Wstrict-prototypes -Os -fomit-frame-pointer -I${S}/include" 96 LINUX_HOSTCFLAGS="-Wall -Wstrict-prototypes -Os -fomit-frame-pointer -I${S}/include"
97
98# debugging functions
99#==============================================================
100# this function exists only to help debug kernel-2.eclass
101# if you are adding new functionality in, put a call to it
102# at the start of src_unpack, or during SRC_URI/dep generation.
103debug-print-kernel2-variables() {
104 for v in PVR CKV OKV KV KV_FULL KV_MAJOR KV_MINOR KV_PATCH RELEASETYPE \
105 RELEASE UNIPATCH_LIST_DEFAULT UNIPATCH_LIST_GENPATCHES \
106 UNIPATCH_LIST S KERNEL_URI ; do
107 debug-print "${v}: ${!v}"
108 done
109}
59 110
60#Eclass functions only from here onwards ... 111#Eclass functions only from here onwards ...
61#============================================================== 112#==============================================================
113handle_genpatches() {
114 local tarball
115 [[ -z ${K_WANT_GENPATCHES} || -z ${K_GENPATCHES_VER} ]] && return 1
116
117 for i in ${K_WANT_GENPATCHES} ; do
118 tarball="genpatches-${OKV}-${K_GENPATCHES_VER}.${i}.tar.bz2"
119 GENPATCHES_URI="${GENPATCHES_URI} mirror://gentoo/${tarball}"
120 UNIPATCH_LIST_GENPATCHES="${UNIPATCH_LIST_GENPATCHES} ${DISTDIR}/${tarball}"
121 done
122}
123
124detect_version() {
125 # this function will detect and set
126 # - OKV: Original Kernel Version (2.6.0/2.6.0-test11)
127 # - KV: Kernel Version (2.6.0-gentoo/2.6.0-test11-gentoo-r1)
128 # - EXTRAVERSION: The additional version appended to OKV (-gentoo/-gentoo-r1)
129
130 if [[ -n ${KV_FULL} ]]; then
131 # we will set this for backwards compatibility.
132 KV=${KV_FULL}
133
134 # we know KV_FULL so lets stop here. but not without resetting S
135 S=${WORKDIR}/linux-${KV_FULL}
136 return
137 fi
138
139 # CKV is used as a comparison kernel version, which is used when
140 # PV doesnt reflect the genuine kernel version.
141 # this gets set to the portage style versioning. ie:
142 # CKV=2.6.11_rc4
143 CKV=${CKV:-${PV}}
144 OKV=${OKV:-${CKV}}
145 OKV=${OKV/_beta/-test}
146 OKV=${OKV/_rc/-rc}
147 OKV=${OKV/-r*}
148 OKV=${OKV/_p*}
149
150 KV_MAJOR=$(get_version_component_range 1 ${OKV})
151 KV_MINOR=$(get_version_component_range 2 ${OKV})
152 KV_PATCH=$(get_version_component_range 3 ${OKV})
153
154 if [[ ${KV_MAJOR}${KV_MINOR}${KV_PATCH} -ge 269 ]]; then
155 KV_EXTRA=$(get_version_component_range 4- ${OKV})
156 KV_EXTRA=${KV_EXTRA/[-_]*}
157 else
158 KV_PATCH=$(get_version_component_range 3- ${OKV})
159 fi
160 KV_PATCH=${KV_PATCH/[-_]*}
161
162 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2"
163
164 RELEASE=${CKV/${OKV}}
165 RELEASE=${RELEASE/_beta}
166 RELEASE=${RELEASE/_rc/-rc}
167 RELEASE=${RELEASE/_pre/-pre}
168 kernel_is ge 2 6 && RELEASE=${RELEASE/-pre/-git}
169 RELEASETYPE=${RELEASE//[0-9]}
170
171 # Now we know that RELEASE is the -rc/-git
172 # and RELEASETYPE is the same but with its numerics stripped
173 # we can work on better sorting EXTRAVERSION.
174 # first of all, we add the release
175 EXTRAVERSION="${RELEASE}"
176 debug-print "0 EXTRAVERSION:${EXTRAVERSION}"
177 [[ -n ${KV_EXTRA} ]] && EXTRAVERSION=".${KV_EXTRA}${EXTRAVERSION}"
178
179 debug-print "1 EXTRAVERSION:${EXTRAVERSION}"
180 if [[ -n "${K_NOUSEPR}" ]]; then
181 # Don't add anything based on PR to EXTRAVERSION
182 debug-print "1.0 EXTRAVERSION:${EXTRAVERSION}"
183 elif [[ -n ${K_PREPATCHED} ]]; then
184 debug-print "1.1 EXTRAVERSION:${EXTRAVERSION}"
185 EXTRAVERSION="${EXTRAVERSION}-${PN/-*}${PR/r}"
186 elif [[ "${ETYPE}" = "sources" ]]; then
187 debug-print "1.2 EXTRAVERSION:${EXTRAVERSION}"
188 # For some sources we want to use the PV in the extra version
189 # This is because upstream releases with a completely different
190 # versioning scheme.
191 case ${PN/-*} in
192 wolk) K_USEPV=1;;
193 vserver) K_USEPV=1;;
194 esac
195
196 [[ -z "${K_NOUSENAME}" ]] && EXTRAVERSION="${EXTRAVERSION}-${PN/-*}"
197 [[ -n "${K_USEPV}" ]] && EXTRAVERSION="${EXTRAVERSION}-${PV//_/-}"
198 [[ -n "${PR//r0}" ]] && EXTRAVERSION="${EXTRAVERSION}-${PR}"
199 fi
200 debug-print "2 EXTRAVERSION:${EXTRAVERSION}"
201
202 # The only messing around which should actually effect this is for KV_EXTRA
203 # since this has to limit OKV to MAJ.MIN.PAT and strip EXTRA off else
204 # KV_FULL evaluates to MAJ.MIN.PAT.EXT.EXT after EXTRAVERSION
205 if [[ -n ${KV_EXTRA} ]]; then
206 OKV="${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}"
207 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/patch-${CKV}.bz2
208 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}.tar.bz2"
209 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${CKV}.bz2"
210 fi
211
212 # We need to set this using OKV, but we need to set it before we do any
213 # messing around with OKV based on RELEASETYPE
214 KV_FULL=${OKV}${EXTRAVERSION}
215
216 # we will set this for backwards compatibility.
217 S=${WORKDIR}/linux-${KV_FULL}
218 KV=${KV_FULL}
219
220 # -rc-git pulls can be achieved by specifying CKV
221 # for example:
222 # CKV="2.6.11_rc3_pre2"
223 # will pull:
224 # linux-2.6.10.tar.bz2 & patch-2.6.11-rc3.bz2 & patch-2.6.11-rc3-git2.bz2
225
226 if [[ ${RELEASETYPE} == -rc ]] || [[ ${RELEASETYPE} == -pre ]]; then
227 OKV="${KV_MAJOR}.${KV_MINOR}.$((${KV_PATCH} - 1))"
228 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/testing/patch-${CKV//_/-}.bz2
229 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2"
230 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${CKV//_/-}.bz2"
231 fi
232
233 if [[ ${RELEASETYPE} == -git ]]; then
234 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/snapshots/patch-${OKV}${RELEASE}.bz2
235 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2"
236 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${OKV}${RELEASE}.bz2"
237 fi
238
239 if [[ ${RELEASETYPE} == -rc-git ]]; then
240 OKV="${KV_MAJOR}.${KV_MINOR}.$((${KV_PATCH} - 1))"
241 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/snapshots/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.bz2
242 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/testing/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE/-git*}.bz2
243 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2"
244 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE/-git*}.bz2 ${DISTDIR}/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.bz2"
245 fi
246
247 debug-print-kernel2-variables
248
249 handle_genpatches
250}
251
62kernel_is() { 252kernel_is() {
63 local RESULT 253 # ALL of these should be set before we can safely continue this function.
64 RESULT=1 254 # some of the sources have in the past had only one set.
65 255 local v n=0
66 if [ -n "${1}" ] 256 for v in OKV KV_{MAJOR,MINOR,PATCH} ; do [[ -z ${!v} ]] && n=1 ; done
67 then 257 [[ $n -eq 1 ]] && detect_version
68 [ "${1}" = "${KV_MAJOR}" ] && RESULT=0 258 unset v n
69 fi 259
70 260 # Now we can continue
71 if [ -n "${2}" ] 261 local operator test value x=0 y=0 z=0
72 then 262
73 RESULT=1 263 case ${1} in
74 [ "${2}" = "${KV_MINOR}" ] && RESULT=0 264 lt) operator="-lt"; shift;;
75 fi 265 gt) operator="-gt"; shift;;
76 266 le) operator="-le"; shift;;
77 if [ -n "${3}" ] 267 ge) operator="-ge"; shift;;
78 then 268 eq) operator="-eq"; shift;;
79 RESULT=1 269 *) operator="-eq";;
80 [ "${3}" = "${KV_PATCH}" ] && RESULT=0 270 esac
81 fi 271
82 return ${RESULT} 272 for x in ${@}; do
273 for((y=0; y<$((3 - ${#x})); y++)); do value="${value}0"; done
274 value="${value}${x}"
275 z=$((${z} + 1))
276
277 case ${z} in
278 1) for((y=0; y<$((3 - ${#KV_MAJOR})); y++)); do test="${test}0"; done;
279 test="${test}${KV_MAJOR}";;
280 2) for((y=0; y<$((3 - ${#KV_MINOR})); y++)); do test="${test}0"; done;
281 test="${test}${KV_MINOR}";;
282 3) for((y=0; y<$((3 - ${#KV_PATCH})); y++)); do test="${test}0"; done;
283 test="${test}${KV_PATCH}";;
284 *) die "Error in kernel-2_kernel_is(): Too many parameters.";;
285 esac
286 done
287
288 [ ${test} ${operator} ${value} ] && return 0 || return 1
83} 289}
84 290
85kernel_is_2_4() { 291kernel_is_2_4() {
86 kernel_is 2 4 292 kernel_is 2 4
87 return $?
88} 293}
89 294
90kernel_is_2_6() { 295kernel_is_2_6() {
91 [ ${KV_MAJOR} -eq 2 -a ${KV_MINOR} -eq 5 -o ${KV_MINOR} -eq 6 ] && \ 296 kernel_is 2 6 || kernel_is 2 5
92 return 0 || return 1
93}
94
95kernel_header_destdir() {
96 [ "${CTARGET}" = "${CHOST}" ] \
97 && echo /usr/include \
98 || echo /usr/${CTARGET}/include
99} 297}
100 298
101# Capture the sources type and set DEPENDs 299# Capture the sources type and set DEPENDs
102if [ "${ETYPE}" == "sources" ] 300if [[ ${ETYPE} == sources ]]; then
103then
104 # binutils version needed to avoid Athlon/PIII/SSE assembler bugs.
105 DEPEND="!build? ( sys-apps/sed 301 DEPEND="!build? ( sys-apps/sed
106 >=sys-devel/binutils-2.11.90.0.31 ) 302 >=sys-devel/binutils-2.11.90.0.31 )"
107 doc? ( !arm? ( !s390? ( app-text/docbook-sgml-utils ) ) )"
108
109 RDEPEND="${DEPEND}
110 !build? ( >=sys-libs/ncurses-5.2 303 RDEPEND="!build? ( >=sys-libs/ncurses-5.2
111 dev-lang/perl
112 sys-apps/module-init-tools
113 sys-devel/make )" 304 sys-devel/make )"
114 305 PDEPEND="!build? ( virtual/dev-manager )"
115 [ $(kernel_is_2_4) $? == 0 ] && PROVIDE="virtual/linux-sources" \ 306
116 || PROVIDE="virtual/linux-sources virtual/alsa" 307 PROVIDE="virtual/linux-sources"
308 kernel_is gt 2 4 && PROVIDE="${PROVIDE} virtual/alsa"
117 309
310 SLOT="${PVR}"
311 DESCRIPTION="Sources for the ${KV_MAJOR}.${KV_MINOR} linux kernel"
312 IUSE="symlink build"
313
314 # Bug #266157, deblob for libre support
315 if [[ -z ${K_PREDEBLOBBED} ]] ; then
316 if [[ -z ${K_DEBLOB_AVAILABLE} ]] ; then
317 kernel_is ge 2 6 27 && \
318 kernel_is le 2 6 ${DEBLOB_MAX_VERSION} && \
319 K_DEBLOB_AVAILABLE=1
320 fi
321 if [[ ${K_DEBLOB_AVAILABLE} == "1" ]] ; then
322 IUSE="${IUSE} deblob"
323 # Reflect that kernels contain firmware blobs unless otherwise
324 # stripped
325 LICENSE="${LICENSE} !deblob? ( freedist )"
326
327 DEBLOB_PV="${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}"
328 DEBLOB_A="deblob-${DEBLOB_PV}"
329 DEBLOB_HOMEPAGE="http://www.fsfla.org/svnwiki/selibre/linux-libre/"
330 HOMEPAGE="${HOMEPAGE} ${DEBLOB_HOMEPAGE}"
331
332 KERNEL_URI="${KERNEL_URI}
333 deblob? (
334 ${DEBLOB_HOMEPAGE}/download/releases/LATEST-${DEBLOB_PV}.N/${DEBLOB_A}
335 )"
336 else
337 # We have no way to deblob older kernels, so just mark them as
338 # tainted with non-libre materials.
339 LICENSE="${LICENSE} freedist"
340 fi
341 fi
342
118elif [ "${ETYPE}" == "headers" ] 343elif [[ ${ETYPE} == headers ]]; then
119then 344 DESCRIPTION="Linux system headers"
345
346 # Since we should NOT honour KBUILD_OUTPUT in headers
347 # lets unset it here.
348 unset KBUILD_OUTPUT
349
350 if [[ ${CTARGET} = ${CHOST} ]]; then
351 DEPEND="!virtual/os-headers"
120 PROVIDE="virtual/kernel virtual/os-headers" 352 PROVIDE="virtual/os-headers"
353 SLOT="0"
354 else
355 SLOT="${CTARGET}"
356 fi
121else 357else
122 eerror "Unknown ETYPE=\"${ETYPE}\", must be \"sources\" or \"headers\"" 358 eerror "Unknown ETYPE=\"${ETYPE}\", must be \"sources\" or \"headers\""
123 die 359 die "Unknown ETYPE=\"${ETYPE}\", must be \"sources\" or \"headers\""
124fi 360fi
361
362# Cross-compile support functions
363#==============================================================
364kernel_header_destdir() {
365 [[ ${CTARGET} == ${CHOST} ]] \
366 && echo /usr/include \
367 || echo /usr/${CTARGET}/usr/include
368}
369
370cross_pre_c_headers() {
371 use crosscompile_opts_headers-only && [[ ${CHOST} != ${CTARGET} ]]
372}
373
374env_setup_xmakeopts() {
375 # Kernel ARCH != portage ARCH
376 export KARCH=$(tc-arch-kernel)
377
378 # When cross-compiling, we need to set the ARCH/CROSS_COMPILE
379 # variables properly or bad things happen !
380 xmakeopts="ARCH=${KARCH}"
381 if [[ ${CTARGET} != ${CHOST} ]] && ! cross_pre_c_headers ; then
382 xmakeopts="${xmakeopts} CROSS_COMPILE=${CTARGET}-"
383 elif type -p ${CHOST}-ar > /dev/null ; then
384 xmakeopts="${xmakeopts} CROSS_COMPILE=${CHOST}-"
385 fi
386 export xmakeopts
387}
125 388
126# Unpack functions 389# Unpack functions
127#============================================================== 390#==============================================================
128unpack_2_4() { 391unpack_2_4() {
129 cd ${S}
130 # this file is required for other things to build properly, 392 # this file is required for other things to build properly,
131 # so we autogenerate it 393 # so we autogenerate it
132 make mrproper || die "make mrproper died" 394 make -s mrproper ${xmakeopts} || die "make mrproper failed"
395 make -s symlinks ${xmakeopts} || die "make symlinks failed"
133 make include/linux/version.h || die "make include/linux/version.h failed" 396 make -s include/linux/version.h ${xmakeopts} || die "make include/linux/version.h failed"
134 echo ">>> version.h compiled successfully." 397 echo ">>> version.h compiled successfully."
135} 398}
136 399
400unpack_2_6() {
401 # this file is required for other things to build properly, so we
402 # autogenerate it ... generate a .config to keep version.h build from
403 # spitting out an annoying warning
404 make -s mrproper ${xmakeopts} 2>/dev/null \
405 || die "make mrproper failed"
406
407 # quick fix for bug #132152 which triggers when it cannot include linux
408 # headers (ie, we have not installed it yet)
409 if ! make -s defconfig ${xmakeopts} &>/dev/null 2>&1 ; then
410 touch .config
411 eerror "make defconfig failed."
412 eerror "assuming you dont have any headers installed yet and continuing"
413 epause 5
414 fi
415
416 make -s include/linux/version.h ${xmakeopts} 2>/dev/null \
417 || die "make include/linux/version.h failed"
418 rm -f .config >/dev/null
419}
420
137universal_unpack() { 421universal_unpack() {
138 [ -z "${OKV}" ] && OKV="${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}"
139
140 cd ${WORKDIR} 422 cd "${WORKDIR}"
141 unpack linux-${OKV}.tar.bz2 423 unpack linux-${OKV}.tar.bz2
424 if [[ -d "linux" ]]; then
425 mv linux linux-${KV_FULL} \
426 || die "Unable to move source tree to ${KV_FULL}."
142 if [ "${OKV}" != "${KV_FULL}" ] 427 elif [[ "${OKV}" != "${KV_FULL}" ]]; then
143 then
144 mv linux-${OKV} linux-${KV_FULL} \ 428 mv linux-${OKV} linux-${KV_FULL} \
145 || die "Unable to move source tree to ${KV_FULL}." 429 || die "Unable to move source tree to ${KV_FULL}."
146 fi 430 fi
147 cd ${S} 431 cd "${S}"
148 432
149 # change incorrect install path
150 sed -ie 's:#export\tINSTALL_PATH:export\tINSTALL_PATH:' Makefile
151
152 # remove all backup files 433 # remove all backup files
153 find . -iname "*~" -exec rm {} \; 2> /dev/null 434 find . -iname "*~" -exec rm {} \; 2> /dev/null
154 435
155 if [ -d "${S}/Documentation/DocBook" ] 436 # fix a problem on ppc where TOUT writes to /usr/src/linux breaking sandbox
437 # only do this for kernel < 2.6.27 since this file does not exist in later
438 # kernels
439 if [[ ${KV_MAJOR}.${KV_MINOR}.${KV_PATCH} < 2.6.27 ]]
156 then 440 then
157 cd ${S}/Documentation/DocBook 441 sed -i \
158 sed -e "s:db2:docbook2:g" Makefile > Makefile.new \ 442 -e 's|TOUT := .tmp_gas_check|TOUT := $(T).tmp_gas_check|' \
159 && mv Makefile.new Makefile 443 "${S}"/arch/ppc/Makefile
160 cd ${S} 444 else
445 sed -i \
446 -e 's|TOUT := .tmp_gas_check|TOUT := $(T).tmp_gas_check|' \
447 "${S}"/arch/powerpc/Makefile
161 fi 448 fi
162} 449}
163 450
164unpack_set_extraversion() { 451unpack_set_extraversion() {
165 cd ${S} 452 cd "${S}"
166 sed -ie "s:^\(EXTRAVERSION =\).*:\1 ${EXTRAVERSION}:" Makefile 453 sed -i -e "s:^\(EXTRAVERSION =\).*:\1 ${EXTRAVERSION}:" Makefile
454 cd "${OLDPWD}"
455}
456
457# Should be done after patches have been applied
458# Otherwise patches that modify the same area of Makefile will fail
459unpack_fix_install_path() {
460 cd "${S}"
461 sed -i -e 's:#export\tINSTALL_PATH:export\tINSTALL_PATH:' Makefile
167} 462}
168 463
169# Compile Functions 464# Compile Functions
170#============================================================== 465#==============================================================
171compile_headers() { 466compile_headers() {
172 local MY_ARCH 467 env_setup_xmakeopts
173 468
174 MY_ARCH=${ARCH} 469 # if we couldnt obtain HOSTCFLAGS from the Makefile,
175 unset ${ARCH} 470 # then set it to something sane
471 local HOSTCFLAGS=$(getfilevar HOSTCFLAGS "${S}"/Makefile)
472 HOSTCFLAGS=${HOSTCFLAGS:--Wall -Wstrict-prototypes -O2 -fomit-frame-pointer}
473
474 if kernel_is 2 4; then
176 yes "" | make oldconfig 475 yes "" | make oldconfig ${xmakeopts}
177 echo ">>> make oldconfig complete" 476 echo ">>> make oldconfig complete"
178 ARCH=${MY_ARCH} 477 make dep ${xmakeopts}
179} 478 elif kernel_is 2 6; then
479 # 2.6.18 introduces headers_install which means we dont need any
480 # of this crap anymore :D
481 kernel_is ge 2 6 18 && return 0
180 482
181compile_manpages() { 483 # autoconf.h isnt generated unless it already exists. plus, we have
182 local MY_ARCH 484 # no guarantee that any headers are installed on the system...
485 [[ -f ${ROOT}/usr/include/linux/autoconf.h ]] \
486 || touch include/linux/autoconf.h
183 487
184 einfo "Making manpages ..." 488 # if K_DEFCONFIG isn't set, force to "defconfig"
185 MY_ARCH=${ARCH} 489 # needed by mips
186 unset ARCH 490 if [[ -z ${K_DEFCONFIG} ]]; then
187 make mandocs 491 if [[ $(KV_to_int ${KV}) -ge $(KV_to_int 2.6.16) ]]; then
188 ARCH=${MY_ARCH} 492 case ${CTARGET} in
493 powerpc64*) K_DEFCONFIG="ppc64_defconfig";;
494 powerpc*) K_DEFCONFIG="pmac32_defconfig";;
495 *) K_DEFCONFIG="defconfig";;
496 esac
497 else
498 K_DEFCONFIG="defconfig"
499 fi
500 fi
501
502 # if there arent any installed headers, then there also isnt an asm
503 # symlink in /usr/include/, and make defconfig will fail, so we have
504 # to force an include path with $S.
505 HOSTCFLAGS="${HOSTCFLAGS} -I${S}/include/"
506 ln -sf asm-${KARCH} "${S}"/include/asm
507 cross_pre_c_headers && return 0
508
509 make ${K_DEFCONFIG} HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "defconfig failed (${K_DEFCONFIG})"
510 if compile_headers_tweak_config ; then
511 yes "" | make oldconfig HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "2nd oldconfig failed"
512 fi
513 make prepare HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "prepare failed"
514 make prepare-all HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "prepare failed"
515 fi
516}
517
518compile_headers_tweak_config() {
519 # some targets can be very very picky, so let's finesse the
520 # .config based upon any info we may have
521 case ${CTARGET} in
522 sh*)
523 sed -i '/CONFIG_CPU_SH/d' .config
524 echo "CONFIG_CPU_SH${CTARGET:2:1}=y" >> .config
525 return 0;;
526 esac
527
528 # no changes, so lets do nothing
529 return 1
189} 530}
190 531
191# install functions 532# install functions
192#============================================================== 533#==============================================================
193install_universal() { 534install_universal() {
194 #fix silly permissions in tarball 535 #fix silly permissions in tarball
195 cd ${WORKDIR} 536 cd "${WORKDIR}"
196 chown -R root:root * 537 chown -R root:0 * >& /dev/null
197 chmod -R a+r-w+X,u+w * 538 chmod -R a+r-w+X,u+w *
539 cd ${OLDPWD}
198} 540}
199 541
200install_headers() { 542install_headers() {
201 [ $(kernel_is_2_4) $? == 0 ] && unpack_2_4
202
203 local ddir=$(kernel_header_destdir) 543 local ddir=$(kernel_header_destdir)
544
545 # 2.6.18 introduces headers_install which means we dont need any
546 # of this crap anymore :D
547 if kernel_is ge 2 6 18 ; then
548 env_setup_xmakeopts
549 emake headers_install INSTALL_HDR_PATH="${D}"/${ddir}/.. ${xmakeopts} || die
550
551 # let other packages install some of these headers
552 rm -rf "${D}"/${ddir}/sound #alsa-headers
553 rm -rf "${D}"/${ddir}/scsi #glibc/uclibc/etc...
554 return 0
555 fi
556
557 # Do not use "linux/*" as that can cause problems with very long
558 # $S values where the cmdline to cp is too long
204 cd ${S} 559 cd "${S}"
205 dodir ${ddir}/linux 560 dodir ${ddir}/linux
206 ln -sf ${S}/include/asm-${ARCH} ${S}/include/asm 561 cp -pPR "${S}"/include/linux "${D}"/${ddir}/ || die
207 cp -ax ${S}/include/linux/* ${D}/${ddir}/linux
208 rm -rf ${D}/${ddir}/linux/modules 562 rm -rf "${D}"/${ddir}/linux/modules
209 563
564 # Handle multilib headers and crap
565 local multi_dirs="" multi_defs=""
566 case $(tc-arch-kernel) in
567 sparc64)
568 multi_dirs="sparc sparc64"
569 multi_defs="!__arch64__ __arch64__"
570 ;;
571 x86_64)
572 multi_dirs="i386 x86_64"
573 multi_defs="__i386__ __x86_64__"
574 ;;
575 ppc64)
576 multi_dirs="ppc ppc64"
577 multi_defs="!__powerpc64__ __powerpc64__"
578 ;;
579 s390x)
580 multi_dirs="s390 s390x"
581 multi_defs="!__s390x__ __s390x__"
582 ;;
583 arm)
210 dodir ${ddir}/asm 584 dodir ${ddir}/asm
211 cp -ax ${S}/include/asm/* ${D}/${ddir}/asm 585 cp -pPR "${S}"/include/asm/* "${D}"/${ddir}/asm
212 586 [[ ! -e ${D}/${ddir}/asm/arch ]] && ln -sf arch-ebsa285 "${D}"/${ddir}/asm/arch
213 if [ $(kernel_is_2_6) $? == 0 ] 587 [[ ! -e ${D}/${ddir}/asm/proc ]] && ln -sf proc-armv "${D}"/${ddir}/asm/proc
214 then 588 ;;
589 powerpc)
590 dodir ${ddir}/asm
591 cp -pPR "${S}"/include/asm/* "${D}"/${ddir}/asm
592 if [[ -e "${S}"/include/asm-ppc ]] ; then
593 dodir ${ddir}/asm-ppc
594 cp -pPR "${S}"/include/asm-ppc/* "${D}"/${ddir}/asm-ppc
595 fi
596 ;;
597 *)
598 dodir ${ddir}/asm
599 cp -pPR "${S}"/include/asm/* "${D}"/${ddir}/asm
600 ;;
601 esac
602 if [[ -n ${multi_dirs} ]] ; then
603 local d ml_inc=""
604 for d in ${multi_dirs} ; do
605 dodir ${ddir}/asm-${d}
606 cp -pPR "${S}"/include/asm-${d}/* "${D}"/${ddir}/asm-${d}/ || die "cp asm-${d} failed"
607
608 ml_inc="${ml_inc} ${multi_defs%% *}:${ddir}/asm-${d}"
609 multi_defs=${multi_defs#* }
610 done
611 create_ml_includes ${ddir}/asm ${ml_inc}
612 fi
613
614 if kernel_is 2 6; then
215 dodir ${ddir}/asm-generic 615 dodir ${ddir}/asm-generic
216 cp -ax ${S}/include/asm-generic/* ${D}/${ddir}/asm-generic 616 cp -pPR "${S}"/include/asm-generic/* "${D}"/${ddir}/asm-generic
217 fi 617 fi
618
619 # clean up
620 find "${D}" -name '*.orig' -exec rm -f {} \;
621
622 cd ${OLDPWD}
218} 623}
219 624
220install_sources() { 625install_sources() {
221 local doc
222 local docs
223 local file 626 local file
224 627
225 cd ${S} 628 cd "${S}"
226 dodir /usr/src 629 dodir /usr/src
227 echo ">>> Copying sources ..." 630 echo ">>> Copying sources ..."
631
228 file="$(find ${WORKDIR} -iname "docs" -type d)" 632 file="$(find ${WORKDIR} -iname "docs" -type d)"
229 if [ -n "${file}" ] 633 if [[ -n ${file} ]]; then
230 then
231 for file in $(find ${file} -type f) 634 for file in $(find ${file} -type f); do
232 do
233 echo "${file/*docs\//}" >> ${S}/patches.txt 635 echo "${file//*docs\/}" >> "${S}"/patches.txt
234 echo "===================================================" >> ${S}/patches.txt 636 echo "===================================================" >> "${S}"/patches.txt
235 cat ${file} >> ${S}/patches.txt 637 cat ${file} >> "${S}"/patches.txt
236 echo "===================================================" >> ${S}/patches.txt 638 echo "===================================================" >> "${S}"/patches.txt
237 echo "" >> ${S}/patches.txt 639 echo "" >> "${S}"/patches.txt
238 done 640 done
239 fi 641 fi
240 642
241 if [ ! -f ${S}/patches.txt ] 643 if [[ ! -f ${S}/patches.txt ]]; then
242 then
243 # patches.txt is empty so lets use our ChangeLog 644 # patches.txt is empty so lets use our ChangeLog
244 [ -f ${FILESDIR}/../ChangeLog ] && echo "Please check the ebuild ChangeLog for more details." > ${S}/patches.txt 645 [[ -f ${FILESDIR}/../ChangeLog ]] && \
646 echo "Please check the ebuild ChangeLog for more details." \
647 > "${S}"/patches.txt
245 fi 648 fi
246 649
247 for doc in ${UNIPATCH_DOCS}
248 do
249 [ -f ${doc} ] && docs="${docs} ${doc}"
250 done
251
252 if [ -f ${S}/patches.txt ]; then
253 docs="${docs} ${S}/patches.txt"
254 fi
255
256 if use doc && ! use arm && ! use s390; then
257 install_manpages
258 fi
259
260 dodoc ${docs}
261 mv ${WORKDIR}/linux* ${D}/usr/src 650 mv ${WORKDIR}/linux* "${D}"/usr/src
262}
263
264install_manpages() {
265 local MY_ARCH
266
267 ebegin "Installing manpages"
268 MY_ARCH=${ARCH}
269 unset ARCH
270 sed -ie "s#/usr/local/man#${D}/usr/man#g" scripts/makeman
271 make installmandocs
272 eend $?
273 sed -ie "s#${D}/usr/man#/usr/local/man#g" scripts/makeman
274 ARCH=${MY_ARCH}
275} 651}
276 652
277# pkg_preinst functions 653# pkg_preinst functions
278#============================================================== 654#==============================================================
279preinst_headers() { 655preinst_headers() {
280 local ddir=$(kernel_header_destdir) 656 local ddir=$(kernel_header_destdir)
281 [[ -L ${ROOT}${ddir}/linux ]] && rm "${ROOT}"${ddir}/linux 657 [[ -L ${ddir}/linux ]] && rm ${ddir}/linux
282 [[ -L ${ROOT}${ddir}/asm ]] && rm "${ROOT}"${ddir}/asm 658 [[ -L ${ddir}/asm ]] && rm ${ddir}/asm
283} 659}
284 660
285# pkg_postinst functions 661# pkg_postinst functions
286#============================================================== 662#==============================================================
287postinst_sources() { 663postinst_sources() {
664 local MAKELINK=0
665
666 # if we have USE=symlink, then force K_SYMLINK=1
667 use symlink && K_SYMLINK=1
668
669 # if we're using a deblobbed kernel, it's not supported
670 [[ $K_DEBLOB_AVAILABLE == 1 ]] && \
671 use deblob && \
672 K_SECURITY_UNSUPPORTED=deblob
673
674 # if we are to forcably symlink, delete it if it already exists first.
675 if [[ ${K_SYMLINK} > 0 ]]; then
676 [[ -h ${ROOT}usr/src/linux ]] && rm ${ROOT}usr/src/linux
677 MAKELINK=1
678 fi
679
680 # if the link doesnt exist, lets create it
288 if [ ! -h ${ROOT}usr/src/linux ] 681 [[ ! -h ${ROOT}usr/src/linux ]] && MAKELINK=1
682
683 if [[ ${MAKELINK} == 1 ]]; then
684 cd "${ROOT}"usr/src
685 ln -sf linux-${KV_FULL} linux
686 cd ${OLDPWD}
687 fi
688
689 # Don't forget to make directory for sysfs
690 [[ ! -d ${ROOT}sys ]] && kernel_is 2 6 && mkdir ${ROOT}sys
691
692 echo
693 elog "If you are upgrading from a previous kernel, you may be interested"
694 elog "in the following document:"
695 elog " - General upgrade guide: http://www.gentoo.org/doc/en/kernel-upgrade.xml"
696 echo
697
698 # if K_EXTRAEINFO is set then lets display it now
699 if [[ -n ${K_EXTRAEINFO} ]]; then
700 echo ${K_EXTRAEINFO} | fmt |
701 while read -s ELINE; do einfo "${ELINE}"; done
702 fi
703
704 # if K_EXTRAELOG is set then lets display it now
705 if [[ -n ${K_EXTRAELOG} ]]; then
706 echo ${K_EXTRAELOG} | fmt |
707 while read -s ELINE; do elog "${ELINE}"; done
708 fi
709
710 # if K_EXTRAEWARN is set then lets display it now
711 if [[ -n ${K_EXTRAEWARN} ]]; then
712 echo ${K_EXTRAEWARN} | fmt |
713 while read -s ELINE; do ewarn "${ELINE}"; done
714 fi
715
716 # optionally display security unsupported message
717 # Start with why
718 if [[ ${K_SECURITY_UNSUPPORTED} = deblob ]]; then
719 ewarn "Deblobbed kernels are UNSUPPORTED by Gentoo Security"
720 elif [[ -n ${K_SECURITY_UNSUPPORTED} ]]; then
721 ewarn "${PN} is UNSUPPORTED by Gentoo Security."
722 fi
723 # And now the general message.
724 if [[ -n ${K_SECURITY_UNSUPPORTED} ]]; then
725 ewarn "This means that it is likely to be vulnerable to recent security issues."
726 ewarn "For specific information on why this kernel is unsupported, please read:"
727 ewarn "http://www.gentoo.org/proj/en/security/kernel.xml"
728 fi
729
730 # warn sparc users that they need to do cross-compiling with >= 2.6.25(bug #214765)
731 KV_MAJOR=$(get_version_component_range 1 ${OKV})
732 KV_MINOR=$(get_version_component_range 2 ${OKV})
733 KV_PATCH=$(get_version_component_range 3 ${OKV})
734 if [[ "$(tc-arch)" = "sparc" ]] \
735 && [[ ${KV_MAJOR}.${KV_MINOR}.${KV_PATCH} > 2.6.24 ]]
289 then 736 then
290 ln -sf ${ROOT}usr/src/linux-${KV_FULL} ${ROOT}usr/src/linux
291 fi
292
293 # Don't forget to make directory for sysfs
294 [ ! -d "${ROOT}/sys" -a $(kernel_is_2_6) $? == 0 ] && mkdir /sys
295
296 echo
297 einfo "After installing a new kernel of any version, it is important"
298 einfo "that you have the appropriate /etc/modules.autoload.d/kernel-X.Y"
299 einfo "created (X.Y is the first 2 parts of your new kernel version)"
300 echo
301 einfo "For example, this kernel will require:"
302 einfo "/etc/modules.autoload.d/kernel-${KV_MAJOR}.${KV_MINOR}"
303 echo
304
305 # if K_EXTRAEINFO is set then lets display it now
306 if [ -n "${K_EXTRAEINFO}" ]
307 then
308 echo ${K_EXTRAEINFO} | fmt |
309 while read -s ELINE
310 do
311 einfo "${ELINE}"
312 done
313
314 echo 737 echo
315 fi 738 elog "NOTE: Since 2.6.25 the kernel Makefile has changed in a way that"
316 739 elog "you now need to do"
317 # Show policy version, if this kernel has SELinux ... 740 elog " make CROSS_COMPILE=sparc64-unknown-linux-gnu-"
318 local secfile 741 elog "instead of just"
319 secfile="${ROOT}usr/src/linux-${KV_FULL}/security/selinux/include/security.h" 742 elog " make"
320 if use selinux && [ -f "$secfile" ] 743 elog "to compile the kernel. For more information please browse to"
321 then 744 elog "https://bugs.gentoo.org/show_bug.cgi?id=214765"
322 local polver=$(awk '/POLICYDB_VERSION /{print $3}' $secfile)
323 einfo "The SELinux policy version of this kernel is $polver."
324 echo 745 echo
325 fi 746 fi
326
327 # if K_EXTRAEWARN is set then lets display it now
328 if [ -n "${K_EXTRAEWARN}" ]
329 then
330 echo ${K_EXTRAEWARN} | fmt |
331 while read -s ELINE
332 do
333 ewarn "${ELINE}"
334 done
335
336 echo
337 fi
338} 747}
339 748
340postinst_headers() { 749postinst_headers() {
341 echo
342 einfo "Kernel headers are usually only used when recompiling glibc." 750 elog "Kernel headers are usually only used when recompiling your system libc, as"
343 einfo "Following the installation of newer headers it is advised that" 751 elog "such, following the installation of newer headers, it is advised that you"
344 einfo "you re-merge glibc as follows:" 752 elog "re-merge your system libc."
345 einfo "# emerge glibc"
346 einfo "Failure to do so will cause glibc to not make use of newer" 753 elog "Failure to do so will cause your system libc to not make use of newer"
347 einfo "features present in the updated kernelheaders." 754 elog "features present in the updated kernel headers."
348 echo
349} 755}
350 756
351# pkg_setup functions 757# pkg_setup functions
352#============================================================== 758#==============================================================
353setup_headers() { 759setup_headers() {
354 ARCH=$(uname -m | sed -e s/[i].86/i386/ -e s/x86/i386/ -e s/sun4u/sparc64/ \
355 -e s/arm.*/arm/ -e s/sa110/arm/ -e s/amd64/x86_64/)
356 [ "$ARCH" == "sparc" -a "$PROFILE_ARCH" == "sparc64" ] && ARCH="sparc64"
357
358 [ -z "${H_SUPPORTEDARCH}" ] && H_SUPPORTEDARCH="${PN/-*/}" 760 [[ -z ${H_SUPPORTEDARCH} ]] && H_SUPPORTEDARCH=${PN/-*/}
359 for i in ${H_SUPPORTEDARCH} 761 for i in ${H_SUPPORTEDARCH}; do
360 do
361 [ "${ARCH}" == "${i}" ] && H_ACCEPT_ARCH="yes" 762 [[ $(tc-arch) == "${i}" ]] && H_ACCEPT_ARCH="yes"
362 done 763 done
363 764
364 if [ "${H_ACCEPT_ARCH}" != "yes" ] 765 if [[ ${H_ACCEPT_ARCH} != "yes" ]]; then
365 then
366 echo 766 echo
367 eerror "This version of ${PN} does not support ${ARCH}." 767 eerror "This version of ${PN} does not support $(tc-arch)."
368 eerror "Please merge the appropriate sources, in most cases" 768 eerror "Please merge the appropriate sources, in most cases"
369 eerror "this will be ${ARCH}-headers." 769 eerror "(but not all) this will be called $(tc-arch)-headers."
370 die "incorrect headers" 770 die "Package unsupported for $(tc-arch)"
371 fi 771 fi
372} 772}
373 773
374# unipatch 774# unipatch
375#============================================================== 775#==============================================================
376unipatch() { 776unipatch() {
377 local i 777 local i x y z extention PIPE_CMD UNIPATCH_DROP KPATCH_DIR PATCH_DEPTH ELINE
378 local x 778 local STRICT_COUNT PATCH_LEVEL myLC_ALL myLANG extglob_bak
379 local extention 779
380 local PIPE_CMD 780 # set to a standard locale to ensure sorts are ordered properly.
381 local UNIPATCH_DROP 781 myLC_ALL="${LC_ALL}"
382 local KPATCH_DIR 782 myLANG="${LANG}"
383 local PATCH_DEPTH 783 LC_ALL="C"
384 local ELINE 784 LANG=""
385 local STRICT_COUNT
386 local PATCH_LEVEL
387 785
388 [ -z "${KPATCH_DIR}" ] && KPATCH_DIR="${WORKDIR}/patches/" 786 [ -z "${KPATCH_DIR}" ] && KPATCH_DIR="${WORKDIR}/patches/"
389 [ ! -d ${KPATCH_DIR} ] && mkdir -p ${KPATCH_DIR} 787 [ ! -d ${KPATCH_DIR} ] && mkdir -p ${KPATCH_DIR}
390 788
391 # We're gonna need it when doing patches with a predefined patchlevel 789 # We're gonna need it when doing patches with a predefined patchlevel
790 extglob_bak=$(shopt -p extglob)
392 shopt -s extglob 791 shopt -s extglob
393 792
394 # This function will unpack all passed tarballs, add any passed patches, and remove any passed patchnumbers 793 # This function will unpack all passed tarballs, add any passed patches, and remove any passed patchnumbers
395 # usage can be either via an env var or by params 794 # usage can be either via an env var or by params
396 # although due to the nature we pass this within this eclass 795 # although due to the nature we pass this within this eclass
397 # it shall be by param only. 796 # it shall be by param only.
398 # -z "${UNIPATCH_LIST}" ] && UNIPATCH_LIST="${@}" 797 # -z "${UNIPATCH_LIST}" ] && UNIPATCH_LIST="${@}"
399 UNIPATCH_LIST="${@}" 798 UNIPATCH_LIST="${@}"
400 799
401 #unpack any passed tarballs 800 #unpack any passed tarballs
402 for i in ${UNIPATCH_LIST} 801 for i in ${UNIPATCH_LIST}; do
403 do
404 if [ -n "$(echo ${i} | grep -e "\.tar" -e "\.tbz" -e "\.tgz")" ] 802 if echo ${i} | grep -qs -e "\.tar" -e "\.tbz" -e "\.tgz" ; then
405 then
406 extention=${i/*./}
407 extention=${extention/:*/}
408 case ${extention} in
409 tbz2) PIPE_CMD="tar -xvjf";;
410 bz2) PIPE_CMD="tar -xvjf";;
411 tgz) PIPE_CMD="tar -xvzf";;
412 gz) PIPE_CMD="tar -xvzf";;
413 *) eerror "Unrecognized tarball compression"
414 die "Unrecognized tarball compression";;
415 esac
416
417 if [ -n "${UNIPATCH_STRICTORDER}" ] 803 if [ -n "${UNIPATCH_STRICTORDER}" ]; then
418 then 804 unset z
419 STRICT_COUNT=$((${STRICT_COUNT} + 1)) 805 STRICT_COUNT=$((10#${STRICT_COUNT} + 1))
420 mkdir -p ${KPATCH_DIR}/${STRICT_COUNT}/ 806 for((y=0; y<$((6 - ${#STRICT_COUNT})); y++));
421 ${PIPE_CMD} ${i/:*/} -C ${KPATCH_DIR}/${STRICT_COUNT}/ 1>/dev/null 807 do z="${z}0";
808 done
809 PATCH_ORDER="${z}${STRICT_COUNT}"
810
811 mkdir -p "${KPATCH_DIR}/${PATCH_ORDER}"
812 pushd "${KPATCH_DIR}/${PATCH_ORDER}" >/dev/null
813 unpack ${i##*/}
814 popd >/dev/null
422 else 815 else
423 ${PIPE_CMD} ${i/:*/} -C ${KPATCH_DIR} 1>/dev/null 816 pushd "${KPATCH_DIR}" >/dev/null
817 unpack ${i##*/}
818 popd >/dev/null
424 fi 819 fi
425 820
426 if [ $? == 0 ]
427 then
428 einfo "${i/*\//} unpacked"
429 [ -n "$(echo ${i} | grep ':')" ] && echo ">>> Strict patch levels not currently supported for tarballed patchsets" 821 [[ ${i} == *:* ]] && echo ">>> Strict patch levels not currently supported for tarballed patchsets"
430 else
431 eerror "Failed to unpack ${i/:*/}"
432 die "unable to unpack patch tarball"
433 fi
434 else 822 else
435 extention=${i/*./} 823 extention=${i/*./}
436 extention=${extention/:*/} 824 extention=${extention/:*/}
437 PIPE_CMD="" 825 PIPE_CMD=""
438 case ${extention} in 826 case ${extention} in
446 834
447 PATCH_LEVEL=${i/*([^:])?(:)} 835 PATCH_LEVEL=${i/*([^:])?(:)}
448 i=${i/:*/} 836 i=${i/:*/}
449 x=${i/*\//} 837 x=${i/*\//}
450 x=${x/\.${extention}/} 838 x=${x/\.${extention}/}
451 839
452 if [ -n "${PIPE_CMD}" ] 840 if [ -n "${PIPE_CMD}" ]; then
453 then
454 if [ ! -r "${i}" ] 841 if [ ! -r "${i}" ]; then
455 then
456 echo 842 echo
457 eerror "FATAL: unable to locate:" 843 eerror "FATAL: unable to locate:"
458 eerror "${i}" 844 eerror "${i}"
459 eerror "for read-only. The file either has incorrect permissions" 845 eerror "for read-only. The file either has incorrect permissions"
460 eerror "or does not exist." 846 eerror "or does not exist."
461 die Unable to locate ${i} 847 die Unable to locate ${i}
462 fi 848 fi
463 849
464 if [ -n "${UNIPATCH_STRICTORDER}" ] 850 if [ -n "${UNIPATCH_STRICTORDER}" ]; then
465 then 851 unset z
466 STRICT_COUNT=$((${STRICT_COUNT} + 1)) 852 STRICT_COUNT=$((10#${STRICT_COUNT} + 1))
853 for((y=0; y<$((6 - ${#STRICT_COUNT})); y++));
854 do z="${z}0";
855 done
856 PATCH_ORDER="${z}${STRICT_COUNT}"
857
467 mkdir -p ${KPATCH_DIR}/${STRICT_COUNT}/ 858 mkdir -p ${KPATCH_DIR}/${PATCH_ORDER}/
468 $(${PIPE_CMD} ${i} > ${KPATCH_DIR}/${STRICT_COUNT}/${x}.patch${PATCH_LEVEL}) 859 $(${PIPE_CMD} ${i} > ${KPATCH_DIR}/${PATCH_ORDER}/${x}.patch${PATCH_LEVEL})
469 else 860 else
470 $(${PIPE_CMD} ${i} > ${KPATCH_DIR}/${x}.patch${PATCH_LEVEL}) 861 $(${PIPE_CMD} ${i} > ${KPATCH_DIR}/${x}.patch${PATCH_LEVEL})
471 fi 862 fi
472 fi 863 fi
473 fi 864 fi
474 done 865 done
475 866
476 #populate KPATCH_DIRS so we know where to look to remove the excludes 867 #populate KPATCH_DIRS so we know where to look to remove the excludes
477 x=${KPATCH_DIR} 868 x=${KPATCH_DIR}
478 KPATCH_DIR="" 869 KPATCH_DIR=""
479 LC_ALL="C"
480 for i in $(find ${x} -type d | sort -n) 870 for i in $(find ${x} -type d | sort -n); do
481 do
482 KPATCH_DIR="${KPATCH_DIR} ${i}" 871 KPATCH_DIR="${KPATCH_DIR} ${i}"
483 done 872 done
484 873
874 # do not apply fbcondecor patch to sparc/sparc64 as it breaks boot
875 # bug #272676
876 if [[ "$(tc-arch)" = "sparc" || "$(tc-arch)" = "sparc64" ]]; then
877 if [[ ${KV_MAJOR}.${KV_MINOR}.${KV_PATCH} > 2.6.28 ]]; then
878 UNIPATCH_DROP="${UNIPATCH_DROP} *_fbcondecor-0.9.6.patch"
879 echo
880 ewarn "fbcondecor currently prevents sparc/sparc64 from booting"
881 ewarn "for kernel versions >= 2.6.29. Removing fbcondecor patch."
882 ewarn "See https://bugs.gentoo.org/show_bug.cgi?id=272676 for details"
883 echo
884 fi
885 fi
886
485 #so now lets get rid of the patchno's we want to exclude 887 #so now lets get rid of the patchno's we want to exclude
486 UNIPATCH_DROP="${UNIPATCH_EXCLUDE} ${UNIPATCH_DROP}" 888 UNIPATCH_DROP="${UNIPATCH_EXCLUDE} ${UNIPATCH_DROP}"
487 for i in ${UNIPATCH_DROP} 889 for i in ${UNIPATCH_DROP}; do
488 do
489 ebegin "Excluding Patch #${i}" 890 ebegin "Excluding Patch #${i}"
490 for x in ${KPATCH_DIR} 891 for x in ${KPATCH_DIR}; do rm -f ${x}/${i}* 2>/dev/null; done
491 do
492 rm -f ${x}/${i}* 2>/dev/null
493 done
494 eend $? 892 eend $?
495 done 893 done
496 894
497 # and now, finally, we patch it :) 895 # and now, finally, we patch it :)
498 for x in ${KPATCH_DIR} 896 for x in ${KPATCH_DIR}; do
499 do
500 for i in $(find ${x} -maxdepth 1 -iname "*.patch*" -or -iname "*.diff*" | sort -n) 897 for i in $(find ${x} -maxdepth 1 -iname "*.patch*" -or -iname "*.diff*" | sort -n); do
501 do
502 STDERR_T="${T}/${i/*\//}" 898 STDERR_T="${T}/${i/*\//}"
503 STDERR_T="${STDERR_T/.patch*/.err}" 899 STDERR_T="${STDERR_T/.patch*/.err}"
504 900
505 [ -z ${i/*.patch*/} ] && PATCH_DEPTH=${i/*.patch/} 901 [ -z ${i/*.patch*/} ] && PATCH_DEPTH=${i/*.patch/}
506 [ -z ${i/*.diff*/} ] && PATCH_DEPTH=${i/*.diff/} 902 #[ -z ${i/*.diff*/} ] && PATCH_DEPTH=${i/*.diff/}
507 903
508 if [ -z "${PATCH_DEPTH}" ]; then 904 if [ -z "${PATCH_DEPTH}" ]; then PATCH_DEPTH=0; fi
509 PATCH_DEPTH=0
510 fi
511 905
512 ebegin "Applying ${i/*\//} (-p${PATCH_DEPTH}+)" 906 ebegin "Applying ${i/*\//} (-p${PATCH_DEPTH}+)"
513 while [ ${PATCH_DEPTH} -lt 5 ] 907 while [ ${PATCH_DEPTH} -lt 5 ]; do
514 do
515 echo "Attempting Dry-run:" >> ${STDERR_T} 908 echo "Attempting Dry-run:" >> ${STDERR_T}
516 echo "cmd: patch -p${PATCH_DEPTH} --dry-run -f < ${i}" >> ${STDERR_T} 909 echo "cmd: patch -p${PATCH_DEPTH} --no-backup-if-mismatch --dry-run -f < ${i}" >> ${STDERR_T}
517 echo "=======================================================" >> ${STDERR_T} 910 echo "=======================================================" >> ${STDERR_T}
518 if [ $(patch -p${PATCH_DEPTH} --dry-run -f < ${i} >> ${STDERR_T}) $? -eq 0 ] 911 if [ $(patch -p${PATCH_DEPTH} --no-backup-if-mismatch --dry-run -f < ${i} >> ${STDERR_T}) $? -eq 0 ]; then
519 then
520 echo "Attempting patch:" > ${STDERR_T} 912 echo "Attempting patch:" > ${STDERR_T}
521 echo "cmd: patch -p${PATCH_DEPTH} -f < ${i}" >> ${STDERR_T} 913 echo "cmd: patch -p${PATCH_DEPTH} --no-backup-if-mismatch -f < ${i}" >> ${STDERR_T}
522 echo "=======================================================" >> ${STDERR_T} 914 echo "=======================================================" >> ${STDERR_T}
523 if [ $(patch -p${PATCH_DEPTH} -f < ${i} >> ${STDERR_T}) "$?" -eq 0 ] 915 if [ $(patch -p${PATCH_DEPTH} --no-backup-if-mismatch -f < ${i} >> ${STDERR_T}) "$?" -eq 0 ]; then
524 then
525 eend 0 916 eend 0
526 rm ${STDERR_T} 917 rm ${STDERR_T}
527 break 918 break
528 else 919 else
529 eend 1 920 eend 1
533 fi 924 fi
534 else 925 else
535 PATCH_DEPTH=$((${PATCH_DEPTH} + 1)) 926 PATCH_DEPTH=$((${PATCH_DEPTH} + 1))
536 fi 927 fi
537 done 928 done
538 if [ ${PATCH_DEPTH} -eq 5 ] 929 if [ ${PATCH_DEPTH} -eq 5 ]; then
539 then
540 eend 1 930 eend 1
541 eerror "Please attach ${STDERR_T} to any bug you may post." 931 eerror "Please attach ${STDERR_T} to any bug you may post."
542 die "Unable to dry-run patch." 932 die "Unable to dry-run patch."
543 fi 933 fi
544 done 934 done
545 done 935 done
546 936
937 # This is a quick, and kind of nasty hack to deal with UNIPATCH_DOCS which
938 # sit in KPATCH_DIR's. This is handled properly in the unipatch rewrite,
939 # which is why I'm not taking too much time over this.
940 local tmp
941 for i in ${UNIPATCH_DOCS}; do
942 tmp="${tmp} ${i//*\/}"
943 cp -f ${i} "${T}"/
944 done
945 UNIPATCH_DOCS="${tmp}"
946
547 # clean up KPATCH_DIR's - fixes bug #53610 947 # clean up KPATCH_DIR's - fixes bug #53610
548 for x in ${KPATCH_DIR} 948 for x in ${KPATCH_DIR}; do rm -Rf ${x}; done
549 do
550 rm -Rf ${x}
551 done
552 unset LC_ALL
553}
554 949
555# custom functions 950 LC_ALL="${myLC_ALL}"
556#============================================================== 951 LANG="${myLANG}"
557detect_version() { 952 eval ${extglob_bak}
558 # this function will detect and set 953}
559 # - OKV: Original Kernel Version (2.6.0/2.6.0-test11) 954
560 # - KV: Kernel Version (2.6.0-gentoo/2.6.0-test11-gentoo-r1) 955# getfilevar accepts 2 vars as follows:
561 # - EXTRAVERSION: The additional version appended to OKV (-gentoo/-gentoo-r1) 956# getfilevar <VARIABLE> <CONFIGFILE>
562 957# pulled from linux-info
563 if [ -n "${KV_FULL}" ] ; 958
564 then 959getfilevar() {
565 # we will set this for backwards compatibility. 960 local workingdir basefname basedname xarch=$(tc-arch-kernel)
566 KV=${KV_FULL} 961
567 962 if [[ -z ${1} ]] && [[ ! -f ${2} ]]; then
568 # we know KV_FULL so lets stop here. but not without resetting S 963 echo -e "\n"
569 S=${WORKDIR}/linux-${KV_FULL} 964 eerror "getfilevar requires 2 variables, with the second a valid file."
570 return 965 eerror " getfilevar <VARIABLE> <CONFIGFILE>"
571 fi
572
573 OKV=${PV/_beta/-test}
574 OKV=${OKV/_rc/-rc}
575 OKV=${OKV/_pre*/}
576 OKV=${OKV/-r*/}
577
578 KV_MAJOR=$(echo ${OKV} | cut -d. -f1)
579 KV_MINOR=$(echo ${OKV} | cut -d. -f2)
580 KV_PATCH=$(echo ${OKV} | cut -d. -f3-)
581 KV_PATCH=${KV_PATCH/[-_]*/}
582
583 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2"
584
585 RELEASE=${PV/${OKV}/}
586 RELEASE=${RELEASE/_beta/}
587 RELEASE=${RELEASE/_rc/-rc}
588 if [ $(kernel_is_2_4) $? == 0 ]
589 then
590 RELEASE=${RELEASE/_pre/-pre}
591 else 966 else
592 RELEASE=${RELEASE/_pre/-bk} 967 workingdir=${PWD}
968 basefname=$(basename ${2})
969 basedname=$(dirname ${2})
970 unset ARCH
971
972 cd ${basedname}
973 echo -e "include ${basefname}\ne:\n\t@echo \$(${1})" | \
974 make ${BUILD_FIXES} -s -f - e 2>/dev/null
975 cd ${workingdir}
976
977 ARCH=${xarch}
593 fi 978 fi
594 RELEASETYPE=${RELEASE//[0-9]/}
595 EXTRAVERSION="${RELEASE}"
596
597 if [ -n "${K_PREPATCHED}" ]
598 then
599 EXTRAVERSION="${EXTRAVERSION}-${PN/-*/}${PR/r/}"
600 else
601 [ -z "${K_NOUSENAME}" ] && EXTRAVERSION="${EXTRAVERSION}-${PN/-*/}"
602 [ "${PR}" != "r0" ] && EXTRAVERSION="${EXTRAVERSION}-${PR}"
603 fi
604
605 KV_FULL=${OKV}${EXTRAVERSION}
606
607 # -rcXX-bkXX pulls are *IMPOSSIBLE* to support within the portage naming convention
608 # these cannot be supported, but the code here can handle it up until this point
609 # and theoretically thereafter.
610
611 if [ "${RELEASETYPE}" == "-rc" -o "${RELEASETYPE}" == "-pre" ]
612 then
613 OKV="${KV_MAJOR}.${KV_MINOR}.$([ $((${KV_PATCH} - 1)) -lt 0 ] && echo ${KV_PATCH} || echo $((${KV_PATCH} - 1)))"
614 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/testing/patch-${PV//_/-}.bz2
615 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2"
616 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${PV//_/-}.bz2"
617 KV_FULL=${PV/[-_]*/}${EXTRAVERSION}
618 fi
619
620 if [ "${RELEASETYPE}" == "-bk" ]
621 then
622 OKV="${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}"
623 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/snapshots/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.bz2
624 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2"
625 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.bz2"
626 KV_FULL=${PV/[-_]*/}${EXTRAVERSION}
627 fi
628
629 if [ "${RELEASETYPE}" == "-rc-bk" ]
630 then
631 OKV="${KV_MAJOR}.${KV_MINOR}.$((${KV_PATCH} - 1))-${RELEASE/-bk*}"
632 EXTRAVERSION="$([ -n "${RELEASE}" ] && echo ${RELEASE/*-bk/-bk})$([ -n "${K_USENAME}" ] && echo -${PN/-*/})$([ ! "${PR}" == "r0" ] && echo -${PR})"
633
634 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/snapshots/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.bz2
635 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2"
636 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.bz2"
637 KV_FULL=${PV/[-_]*/}${EXTRAVERSION}
638 fi
639
640 S=${WORKDIR}/linux-${KV_FULL}
641 # we will set this for backwards compatibility.
642 KV=${KV_FULL}
643} 979}
644 980
645detect_arch() { 981detect_arch() {
646 # This function sets ARCH_URI and ARCH_PATCH 982 # This function sets ARCH_URI and ARCH_PATCH
647 # with the neccessary info for the arch sepecific compatibility 983 # with the neccessary info for the arch sepecific compatibility
648 # patchsets. 984 # patchsets.
649 985
650 local ALL_ARCH 986 local ALL_ARCH LOOP_ARCH COMPAT_URI i
651 local LOOP_ARCH
652 local COMPAT_URI
653 local i
654 987
655 # COMPAT_URI is the contents of ${ARCH}_URI 988 # COMPAT_URI is the contents of ${ARCH}_URI
656 # ARCH_URI is the URI for all the ${ARCH}_URI patches 989 # ARCH_URI is the URI for all the ${ARCH}_URI patches
657 # ARCH_PATCH is ARCH_URI broken into files for UNIPATCH 990 # ARCH_PATCH is ARCH_URI broken into files for UNIPATCH
658 991
659 ARCH_URI="" 992 ARCH_URI=""
660 ARCH_PATCH="" 993 ARCH_PATCH=""
661 ALL_ARCH="X86 PPC PPC64 SPARC MIPS ALPHA ARM HPPA AMD64 IA64 X86OBSD S390" 994 ALL_ARCH="ALPHA AMD64 ARM HPPA IA64 M68K MIPS PPC PPC64 S390 SH SPARC X86"
662 995
663 for LOOP_ARCH in ${ALL_ARCH} 996 for LOOP_ARCH in ${ALL_ARCH}; do
664 do
665 COMPAT_URI="${LOOP_ARCH}_URI" 997 COMPAT_URI="${LOOP_ARCH}_URI"
666 COMPAT_URI="${!COMPAT_URI}" 998 COMPAT_URI="${!COMPAT_URI}"
667 999
668 [ -n "${COMPAT_URI}" ] && \ 1000 [[ -n ${COMPAT_URI} ]] && \
669 ARCH_URI="${ARCH_URI} $(echo ${LOOP_ARCH} | tr '[:upper:]' '[:lower:]')? ( ${COMPAT_URI} )" 1001 ARCH_URI="${ARCH_URI} $(echo ${LOOP_ARCH} | tr '[:upper:]' '[:lower:]')? ( ${COMPAT_URI} )"
670 1002
671 if [ "${LOOP_ARCH}" == "$(echo ${ARCH} | tr '[:lower:]' '[:upper:]')" ] 1003 if [[ ${LOOP_ARCH} == "$(echo $(tc-arch-kernel) | tr '[:lower:]' '[:upper:]')" ]]; then
672 then
673 for i in ${COMPAT_URI} 1004 for i in ${COMPAT_URI}; do
674 do
675 ARCH_PATCH="${ARCH_PATCH} ${DISTDIR}/${i/*\//}" 1005 ARCH_PATCH="${ARCH_PATCH} ${DISTDIR}/${i/*\//}"
676 done 1006 done
677 fi 1007 fi
678 done 1008 done
679} 1009}
680 1010
1011# sparc nastiness
1012#==============================================================
1013# This script generates the files in /usr/include/asm for sparc systems
1014# during installation of sys-kernel/linux-headers.
1015# Will no longer be needed when full 64 bit support is used on sparc64
1016# systems.
1017#
1018# Shamefully ripped from Debian
1019# ----------------------------------------------------------------------
1020
1021# Idea borrowed from RedHat's kernel package
1022
1023# This is gonna get replaced by something in multilib.eclass soon...
1024# --eradicator
1025generate_sparc_asm() {
1026 local name
1027
1028 cd $1 || die
1029 mkdir asm
1030
1031 for h in `( ls asm-sparc; ls asm-sparc64 ) | grep '\.h$' | sort -u`; do
1032 name="$(echo $h | tr a-z. A-Z_)"
1033 # common header
1034 echo "/* All asm/ files are generated and point to the corresponding
1035 * file in asm-sparc or asm-sparc64.
1036 */
1037
1038#ifndef __SPARCSTUB__${name}__
1039#define __SPARCSTUB__${name}__
1040" > asm/${h}
1041
1042 # common for sparc and sparc64
1043 if [ -f asm-sparc/$h -a -f asm-sparc64/$h ]; then
1044 echo "#ifdef __arch64__
1045#include <asm-sparc64/$h>
1046#else
1047#include <asm-sparc/$h>
1048#endif
1049" >> asm/${h}
1050
1051 # sparc only
1052 elif [ -f asm-sparc/$h ]; then
1053echo "#ifndef __arch64__
1054#include <asm-sparc/$h>
1055#endif
1056" >> asm/${h}
1057
1058 # sparc64 only
1059 else
1060echo "#ifdef __arch64__
1061#include <asm-sparc64/$h>
1062#endif
1063" >> asm/${h}
1064 fi
1065
1066 # common footer
1067 echo "#endif /* !__SPARCSTUB__${name}__ */" >> asm/${h}
1068 done
1069 return 0
1070}
1071
1072headers___fix() {
1073 # Voodoo to partially fix broken upstream headers.
1074 # note: do not put inline/asm/volatile together (breaks "inline asm volatile")
1075 sed -i \
1076 -e '/^\#define.*_TYPES_H/{:loop n; bloop}' \
1077 -e 's:\<\([us]\(8\|16\|32\|64\)\)\>:__\1:g' \
1078 -e "s/\([[:space:]]\)inline\([[:space:](]\)/\1__inline__\2/g" \
1079 -e "s/\([[:space:]]\)asm\([[:space:](]\)/\1__asm__\2/g" \
1080 -e "s/\([[:space:]]\)volatile\([[:space:](]\)/\1__volatile__\2/g" \
1081 "$@"
1082}
681 1083
682# common functions 1084# common functions
683#============================================================== 1085#==============================================================
684kernel-2_src_unpack() { 1086kernel-2_src_unpack() {
685 universal_unpack 1087 universal_unpack
686 1088 debug-print "Doing unipatch"
687 [ -n "${UNIPATCH_LIST}" -o -n "${UNIPATCH_LIST_DEFAULT}" ] && \ 1089
1090 [[ -n ${UNIPATCH_LIST} || -n ${UNIPATCH_LIST_DEFAULT} || -n ${UNIPATCH_LIST_GENPATCHES} ]] && \
688 unipatch "${UNIPATCH_LIST_DEFAULT} ${UNIPATCH_LIST}" 1091 unipatch "${UNIPATCH_LIST_DEFAULT} ${UNIPATCH_LIST_GENPATCHES} ${UNIPATCH_LIST}"
689
690 [ -z "${K_NOSETEXTRAVERSION}" ] && \
691 unpack_set_extraversion
692 1092
1093 debug-print "Doing premake"
1094
1095 # allow ebuilds to massage the source tree after patching but before
1096 # we run misc `make` functions below
1097 [[ $(type -t kernel-2_hook_premake) == "function" ]] && kernel-2_hook_premake
1098
1099 debug-print "Doing epatch_user"
1100 epatch_user
1101
1102 debug-print "Doing unpack_set_extraversion"
1103
1104 [[ -z ${K_NOSETEXTRAVERSION} ]] && unpack_set_extraversion
1105 unpack_fix_install_path
1106
1107 # Setup xmakeopts and cd into sourcetree.
1108 env_setup_xmakeopts
1109 cd "${S}"
1110
1111 # We dont need a version.h for anything other than headers
1112 # at least, I should hope we dont. If this causes problems
1113 # take out the if/fi block and inform me please.
1114 # unpack_2_6 should now be 2.6.17 safe anyways
1115 if [[ ${ETYPE} == headers ]]; then
693 kernel_is 2 4 && unpack_2_4 1116 kernel_is 2 4 && unpack_2_4
1117 kernel_is 2 6 && unpack_2_6
1118 fi
1119
1120 if [[ $K_DEBLOB_AVAILABLE == 1 ]] && use deblob ; then
1121 cp "${DISTDIR}/${DEBLOB_A}" "${T}"
1122 chmod +x "${T}/${DEBLOB_A}"
1123 fi
694} 1124}
695 1125
696kernel-2_src_compile() { 1126kernel-2_src_compile() {
1127 cd "${S}"
697 [ "${ETYPE}" == "headers" ] && compile_headers 1128 [[ ${ETYPE} == headers ]] && compile_headers
698 [ "${ETYPE}" == "sources" ] && \ 1129
699 use doc && ! use arm && ! use s390 && compile_manpages 1130 if [[ $K_DEBLOB_AVAILABLE == 1 ]] && use deblob ; then
1131 echo ">>> Running deblob script ..."
1132 sh "${T}/${DEBLOB_A}" --force || \
1133 die "Deblob script failed to run!!!"
1134 fi
700} 1135}
701 1136
702kernel-2_pkg_preinst() { 1137kernel-2_pkg_preinst() {
703 [ "${ETYPE}" == "headers" ] && preinst_headers 1138 [[ ${ETYPE} == headers ]] && preinst_headers
704} 1139}
705 1140
706kernel-2_src_install() { 1141kernel-2_src_install() {
707 install_universal 1142 install_universal
708 [ "${ETYPE}" == "headers" ] && install_headers 1143 [[ ${ETYPE} == headers ]] && install_headers
709 [ "${ETYPE}" == "sources" ] && install_sources 1144 [[ ${ETYPE} == sources ]] && install_sources
710} 1145}
711 1146
712kernel-2_pkg_postinst() { 1147kernel-2_pkg_postinst() {
713 [ "${ETYPE}" == "headers" ] && postinst_headers 1148 [[ ${ETYPE} == headers ]] && postinst_headers
714 [ "${ETYPE}" == "sources" ] && postinst_sources 1149 [[ ${ETYPE} == sources ]] && postinst_sources
715} 1150}
716 1151
717kernel-2_pkg_setup() { 1152kernel-2_pkg_setup() {
1153 if kernel_is 2 4; then
1154 if [ "$( gcc-major-version )" -eq "4" ] ; then
1155 echo
1156 ewarn "Be warned !! >=sys-devel/gcc-4.0.0 isn't supported with linux-2.4!"
1157 ewarn "Either switch to another gcc-version (via gcc-config) or use a"
1158 ewarn "newer kernel that supports gcc-4."
1159 echo
1160 ewarn "Also be aware that bugreports about gcc-4 not working"
1161 ewarn "with linux-2.4 based ebuilds will be closed as INVALID!"
1162 echo
1163 epause 10
1164 fi
1165 fi
1166
1167 ABI="${KERNEL_ABI}"
718 [ "${ETYPE}" == "headers" ] && setup_headers 1168 [[ ${ETYPE} == headers ]] && setup_headers
719
720 # This is to fix some weird portage bug? in stable versions of portage.
721 [ "${ETYPE}" == "sources" ] && echo ">>> Preparing to unpack ..." 1169 [[ ${ETYPE} == sources ]] && echo ">>> Preparing to unpack ..."
722} 1170}
723
724

Legend:
Removed from v.1.60  
changed lines
  Added in v.1.232

  ViewVC Help
Powered by ViewVC 1.1.20